import type { Atom } from 'jotai';
declare type Awaited<T> = T extends Promise<infer V> ? Awaited<V> : T;
declare type Loadable<Value> = {
    state: 'loading';
} | {
    state: 'hasError';
    error: unknown;
} | {
    state: 'hasData';
    data: Awaited<Value>;
};
export declare function loadable<Value>(anAtom: Atom<Value>): Atom<Loadable<Value>>;
export {};
