declare const SUSPENSE_PROMISE: unique symbol;
export declare type SuspensePromise = Promise<void> & {
    [SUSPENSE_PROMISE]: {
        o: Promise<void>;
        c: (() => void) | null;
    };
};
export declare const isSuspensePromise: (promise: Promise<void>) => promise is SuspensePromise;
export declare const isSuspensePromiseAlreadyCancelled: (suspensePromise: SuspensePromise) => boolean;
export declare const cancelSuspensePromise: (suspensePromise: SuspensePromise) => void;
export declare const isEqualSuspensePromise: (oldSuspensePromise: SuspensePromise, newSuspensePromise: SuspensePromise) => boolean;
export declare const createSuspensePromise: (promise: Promise<void>) => SuspensePromise;
export {};
